<?php defined('SYSPATH') or die('No direct script access.');
  
class Model_Teacher extends Model
{
    public $ID;

    public static function with($id) {
        //fixme: teacher may not exist
        if (!is_numeric($id) || $id <= 0)
            throw new LogicException(Error::ID_IS_INCORRECT);

        $t = new self();
        $t->ID = (int) $id;
        return $t;
    }

    /** @return Model_Discipline[] */
    public function getDisciplines() {
        $sql = "CALL `GetDisciplinesForTeacher`(:id); ";
        $query = DB::query(Database::SELECT, $sql)
            ->param(':id', $this->ID)
            ->execute();

        $list = [];
        foreach ($query as $data)
            $list[] = new Model_Discipline($data, true);

        return $list;
    }
}
